<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelAlteracaoDePreco  {

    protected $relAlteracaoDePrecoService;
    protected $utilService;
    
    public function __construct(Services\relAlteracaoDePrecoService $relAlteracaoDePrecoService, Utilities\Util $utilService) {
        $this->relAlteracaoDePrecoService = $relAlteracaoDePrecoService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL'])) {
            $conditions = $this->buildParams($conditions);
    
            $result = $this->relAlteracaoDePrecoService->find($conditions);
        }
        
        $response->addDataSet(new DataSet("orm00034_relAlteracaoDePreco", $result));
        
        return $response;
    }
    
    
        public function buildParams($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        $conditions['CDTABULTPREC'] = implode('_', $conditions['CDTABULTPREC']);
        
        if (empty($conditions['CDOPERADOR'])){
           $conditions['CDOPERADOR'] = 'T';
           }
           else{
           $conditions['CDOPERADOR'] = implode('_', $conditions['CDOPERADOR']);
           }

        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        
        return $conditions;
    }
}